/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Soutez2013;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.image.BufferedImage;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;
import java.util.regex.Pattern;
import javax.imageio.ImageIO;
import javax.swing.JPanel;

/**
 *
 * @author Vašek
 */
public class MapPanel extends JPanel {
    //poznámky
    //v případě chyby vykreslení použít Překreslit vše
    //napřed načíst města vepsáním do pole Město a stisknutím enter, pak cyklit tlačítkem Další město
    
    
    
    
    
    
    
    double x = 1, y = 1;
    int z = 1;
    int mouseX, mouseY;
    String adress = "http://192.168.2.76:80/";
    boolean drag = false;
    String test = "";
    BufferedImage[][] imgs = new BufferedImage[5][5];
    int baseX = -1, baseY = -1, baseZ = -1; //souřadnice, podle kterých se počítá, které obrázky načíst
    boolean loading;
    ArrayList<City> cities = new ArrayList<City>();
    ArrayList<City> curCities = new ArrayList<City>();
    int cityIndex = 0;

    public static void main(String[] args) {
        MapPanel panel = new MapPanel();
        MapFrame frame = new MapFrame(panel);

        frame.setVisible(true);
    }

    public MapPanel() {
        URL url;
        HttpURLConnection connection;
        BufferedReader reader;
        String line;
        try {
            url = new URL("http://192.168.2.76:80/obce.xml");
            connection = (HttpURLConnection) url.openConnection();
            connection.setRequestMethod("GET");
            reader = new BufferedReader(new InputStreamReader(connection.getInputStream()));

            reader.readLine();
            while ((line = reader.readLine()) != null) {

                //<obec jméno="Počátky" x="185958" y="172575"/>
                String[] split = line.split("\"");
                String name;
                int cX, cY;
                if (split.length == 7) {
                    name = split[1];
                    cX = Integer.parseInt(split[3]);
                    cY = Integer.parseInt(split[5]);
                    cities.add(new City(name, cX, cY));
                }
            }
            reader.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void paintComponent(Graphics g) {
        URL url;
        HttpURLConnection connection;
        BufferedReader reader;
        String line;
        //System.out.println("");
        //new imgLoader().run();
        int xDiff = -baseX + (int) x;
        int yDiff = -baseY + (int) y;
        int zDiff = -baseZ + (int) z;
        if (zDiff == 0) {
            if (xDiff != 0 || yDiff != 0) { //je potřeba načíst nové obrázky
                BufferedImage[][] newImgs = new BufferedImage[5][5];
                if (xDiff > 0) { //posun doprava
                    for (int i = xDiff; i < 5; i++) {
                        for (int j = 0; j < 5; j++) {
                            newImgs[i - xDiff][j] = imgs[i][j];
                        }
                    }
                    imgs = newImgs;
                } else if (xDiff < 0) { //posun doleva
                    for (int i = 0; i < 5 + xDiff; i++) {
                        for (int j = 0; j < 5; j++) {
                            newImgs[i - xDiff][j] = imgs[i][j];
                        }
                    }
                    imgs = newImgs;
                } else if (yDiff > 0) { //posun dolu
                    for (int i = 0; i < 5; i++) {
                        for (int j = yDiff; j < 5; j++) {
                            newImgs[i][j - yDiff] = imgs[i][j];
                        }
                    }
                    imgs = newImgs;
                } else if (yDiff < 0) { //posun nahoru
                    for (int i = 0; i < 5; i++) {
                        for (int j = 0; j < 5 + yDiff; j++) {
                            newImgs[i][j - yDiff] = imgs[i][j];
                        }
                    }
                    imgs = newImgs;

                } else {
                    imgs = new BufferedImage[5][5];
                    //    reloadAll();
                }
            }
            if (!loading) {
                new ImgLoader().start();
            }

        } else { //kdyz se zmeni zoom
            imgs = new BufferedImage[5][5];
            new ImgLoader().start();

        }

        for (int i = 0; i < 5; i++) {
            for (int j = 0; j < 5; j++) {
                if (imgs[i][j] == null) {
                    g.setColor(Color.black);
                    g.fillRect((int) ((i - x % 1) * 256), (int) ((j - y % 1) * 256), 256, 256);
                }
                g.drawImage(imgs[i][j], (int) ((i - x % 1) * 256), (int) ((j - y % 1) * 256), this);
                //imgs[i+1][j+1] = ;
            }
        }



        //g.drawString(test, 20, 20);
        baseX = (int) x;
        baseY = (int) y;
        baseZ = z;
    }

    public void setUrl(String to) {
        adress = to;
    }

    public void parallelReload() {
        imgs = new BufferedImage[5][5];
        new ImgLoader().start();
    }

    public void reloadAll() {


        URL url;
        HttpURLConnection connection;

        try {
            for (int i = 0; i < 5; i++) {
                for (int j = 0; j < 5; j++) {
                    imgs[i][j] = null;
                    int tX = ((int) x - 1 + i);
                    int tY = ((int) y - 1 + j);
                    if (tX < 0 || tY < 0 || tX > 3 * Math.pow(2, z) - 1 || tY > 2 * Math.pow(2, z) - 1) {
                        continue;
                    }
                    String add = adress + z + "/" + tX + "/" + tY + ".jpg";
                    url = new URL(add);
                    connection = (HttpURLConnection) url.openConnection();
                    connection.setRequestMethod("GET");
                    imgs[i][j] = ImageIO.read(connection.getInputStream());
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void updateX(String sX) {
        try {
            x = Integer.parseInt(sX);
        } catch (Exception e) {
        }
    }

    public void updateY(String sY) {
        try {
            y = Integer.parseInt(sY);
        } catch (Exception e) {
        }
    }

    public Point.Double updateZ(String sZ) {
        try {
            setZ(Integer.parseInt(sZ));
        } catch (Exception e) {
        }
        return new Point.Double(x, y);
    }

    public void setZ(int to) {
        int change = -z;
        z = to;
        change += z;
        if (change > 0) {
            for (int i = 0; i < change; i++) {
                x *= 2;
                y *= 2;
            }
        } else if (change < 0) {
            for (int i = 0; i < Math.abs(change); i++) {
                x /= 2;
                y /= 2;
            }
        }
    }

    public void setDrag(boolean to) {
        drag = to;
    }

    public void updateDrag(int x, int y) {
        int lastX = mouseX;
        int lastY = mouseY;
        mouseX = x;
        mouseY = y;
        int relX = lastX - mouseX;
        int relY = lastY - mouseY;
        if (drag) {
            this.x += ((double) relX / 256);
            this.y += ((double) relY / 256);
        }
    }

    public void addZ(int add) {
        int newZ = z + add;
        if (newZ < 0) {
            newZ = 0;
        } else if (newZ > 9) {
            newZ = 9;
        }
        setZ(newZ);
    }

    public String goToCity(String name) {
        cityIndex = 0;
        curCities = new ArrayList<City>();
        for (City curVal : cities) {
            
            if (curVal.name.toLowerCase().contains(name.toLowerCase())) {
                curCities.add(curVal);
                //ystem.out.println(curVal.name);
            }
        }
        return nextCity();
    }

    public void goToCity(City to) {
        double newX, newY;
        newX = to.x / Math.pow(2, 9 - z) / 256;
        newY = to.y / Math.pow(2, 9 - z) / 256;
        x = newX;
        y = newY;
        parallelReload();
    }

    public String nextCity() {
        String res = "";
        if (curCities != null && curCities.size() > 0) {
            goToCity(curCities.get(cityIndex));
            res = curCities.get(cityIndex).name;
            cityIndex++;
            cityIndex %= curCities.size();
        }
        return res;
    }

    private class ImgLoader extends Thread {

        @Override
        public void run() {
            if (!loading) {
                loading = true;
                //System.out.println("runnin");
                URL url;
                HttpURLConnection connection;
                double lX = x, lY = y; //místní
                int lZ = z; //místní
                try {
                    for (int i = 0; i < 5; i++) {
                        for (int j = 0; j < 5; j++) {
                            if (imgs[i][j] == null) {
                                int tX = ((int) lX - 1 + i);
                                int tY = ((int) lY - 1 + j);
                                if (tX < 0 || tY < 0 || tX > 3 * Math.pow(2, lZ) - 1 || tY > 2 * Math.pow(2, lZ) - 1) {
                                    continue;
                                }
                                String add = adress + lZ + "/" + tX + "/" + tY + ".jpg";
                                url = new URL(add);
                                connection = (HttpURLConnection) url.openConnection();
                                connection.setRequestMethod("GET");
                                imgs[i][j] = ImageIO.read(connection.getInputStream());
                                repaint();
                            }
                        }
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                } finally {
                    loading = false;
                }
            }
        }
    }
}
            /*
            try {
            for (int i = 0; i < 5; i++) {
            for (int j = 0; j < 5; j++) {
            imgs[i][j] = null;
            int tX = ((int) x - 1 + i);
            int tY = ((int) y - 1 + j);
            if (tX < 0 || tY < 0 || tX > 3 * Math.pow(2, z) - 1 || tY > 2 * Math.pow(2, z) - 1) {
            continue;
            }
            String add = adress + z + "/" + tX + "/" + tY + ".jpg";
            url = new URL(add);
            connection = (HttpURLConnection) url.openConnection();
            connection.setRequestMethod("GET");
            imgs[i][j] = ImageIO.read(connection.getInputStream());
            }
            }
            } catch (Exception e) {
            e.printStackTrace();
            }*/